var neo4j = require('neo4j-driver').v1;
var driver = neo4j.driver("bolt://localhost:7687", neo4j.auth.basic("neo4j", "admin"));
var session = driver.session();
var productos = require('./productos');


exports.initializeOrdenes = function () {
    return session.run("CREATE CONSTRAINT ON (op:OrdenProduccion) ASSERT op.idOrden IS UNIQUE")
}

exports.getOrdenes = function () {
    return session
        .run("MATCH (o:OrdenProduccion) RETURN o")
        .then((result) => {
            return Promise.resolve(result.records.map((orden) => orden._fields[0].properties))
        })
}

exports.deleteAll = function () {
    return session
        .run("MATCH(o:OrdenProduccion) DETACH DELETE o")
        .then(result => {
            return Promise.resolve(result.records.map((orden) => orden._fields[0].properties))
        })
}

exports.getOrden = function (idOrden) {
    return session
        .run("MATCH (o:OrdenProduccion {idOrden: '" + idOrden + "'}) RETURN o")
        .then(result => {
            return Promise.resolve(
                result.records[0]._fields[0].properties
            )
        })
}

exports.updateOrden = function (orden) {
    var asignaciones = ""
    Object.getOwnPropertyNames(orden).forEach((nombrePropiedad) => {
        if (nombrePropiedad !== "idOrden" && nombrePropiedad !== "producto") {
            var eventualApostrofe = typeof(orden[nombrePropiedad]) === "string" ? "'" : ""
            var eventualComa = asignaciones ? ", " : ""
            asignaciones += eventualComa + "o." + nombrePropiedad + " = " + eventualApostrofe + orden[nombrePropiedad] + eventualApostrofe
        }
    })
    if (asignaciones) {
        var query = "MATCH (o:OrdenProduccion {idOrden: '" + orden.idOrden + "'}) SET " + asignaciones
        return session
            .run(query)
            .then(result => {
                return Promise.resolve({
                    orden: result.records.map((orden) => orden._fields[0].properties)
                })

            })
    }
}

exports.addOrden = function (orden) {
    return session
        .run("CREATE (o:OrdenProduccion {idOrden: '" + orden.idOrden + "' })")
        .then(() => {
            exports.updateOrden(orden)
            session.run("MATCH (p:Producto {idProducto: '" + orden.producto.idProducto + "'}) RETURN p")
        })
        .then(result => {
            if (!result) {
                productos.addProducto(orden.producto)
            }
            session.run("MATCH (o:OrdenProduccion {idOrden: '" + orden.idOrden + "'}), (p:Producto {idProducto: '"
            + orden.producto.idProducto + "'}) WITH o, p MERGE (o)-[:FABRICA {cantidad:'"+orden.producto.cantidad+"'}]->(p)")
        })
        .then(() => {
            return Promise.resolve({
                result: "OrdenProduccion agregada correctamente"
            })
        })
        .catch(function (err) {
            done(err)
        })
}

exports.deleteOrden = function (idOrden) {
    return session
        .run("MATCH (o:OrdenProduccion { idOrden: '" + idOrden + "' }) DELETE o")
        .then(() => {
            return Promise.resolve({
                result: "Producto borrado correctamente"
            })
        })
}

exports.linkProducto = function (idProducto) {
    return session
        .run("CREATE (a:Person {name:'Arthur', title:'King'})")
        .then(function () {
            return session.run("MATCH (a:Person) WHERE a.name = 'Arthur' RETURN a.name AS name, a.title AS title")
        })
        .then(function (result) {
            console.log(result.records[0].get("title") + " " + result.records[0].get("name"));
            session.close();
            driver.close();
        })
}
