var expect = require('chai').expect
var should = require('chai').should()
var ordenes = require('../src/models/ordenes')
var babel = require('babel-core/register')


before(function (done) {
    console.log("  ORDENES")
    console.log("  -----------")
    console.log("")
    console.log("  Al comenzar borra todas las ordenes\n")
    ordenes.deleteAll()
    done()
})

describe.skip('Funcionamiento de ABM de las ordenes', function () {
    it('al comenzar la base de datos debería estar en blanco', function (done) {
        ordenes.getOrdenes()
            .then(function (data) {
                expect(JSON.stringify(data)).to.equal("[]")
                done();
            })
            .catch(function (err) {
                done(err)
            })
    })
    it('debería crear una orden y su producto, luego asociarlos', function () {
        var o = {
            idOrden: "123789",
            producto: {
                idProducto: "123"
            },
            fecha: "123",
            cantidad: "1"
        }
        ordenes.addOrden(o)
    })
    it('deberia obtener la orden creada', function () {
        var result = ordenes.getOrden("123789")
        return result.then(function (data) {
            expect(JSON.stringify(data)).to.equal(JSON.stringify({
                "idOrden": "123789"
            }))
        })
    })
    it.skip('no debería duplicar una orden', function (done) {
        var o = {
            idOrden: "123789"
        }
        var result = ordenes.addOrden(o)
        done(result)
    })
    it.skip('debería borrar la orden creada', () => {
        ordenes.deleteOrden("123789");
    })
    it.skip('en este momento la tabla de ordenes debería estar en blanco', function () {
        var result = ordenes.getOrden("123789").then(function (data) {
            expect(data).to.equal({})
        })
    })
})
